/* sane - Scanner Access Now Easy.
	Copyright (C) 2005 Mustek.
	Originally maintained by Mustek
	Author:Jason 2003.04  Roy 2005.09

	This file is part of the SANE package.

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License as
	published by the Free Software Foundation; either version 2 of the
	License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330, Boston,
	MA 02111-1307, USA.

	As a special exception, the authors of SANE give permission for
	additional uses of the libraries contained in this release of SANE.

	The exception is that, if you link a SANE library with other files
	to produce an executable, this does not by itself cause the
	resulting executable to be covered by the GNU General Public
	License.  Your use of that executable is in no way restricted on
	account of linking the SANE library code into it.

	This exception does not, however, invalidate any other reasons why
	the executable file might be covered by the GNU General Public
	License.

	If you submit changes to SANE to the maintainers to be included in
	a subsequent release, you agree by submitting the changes that
	those changes may be distributed with this exception intact.

	If you write modifications of your own for SANE, it is your choice
	whether to permit this exception to apply to your modifications.
	If you do not wish that, delete this exception notice.

	This file provides a generic USB interface.  */
#ifndef _SPICALL_EX_2003_4_7_
#define _SPICALL_EX_2003_4_7_

#include <pthread.h>
#include "../include/typedef.h"
#include "ScannerDefine.h"


extern BOOL g_bOpened;
extern BOOL g_bPrepared;
extern BOOL g_isCanceled;
extern BOOL g_bSharpen;
extern BOOL g_bFirstReadImage;
extern BOOL g_isScanning;
extern BOOL g_isSelfGamma;


extern BYTE g_bScanBits;
extern BYTE* g_lpReadImageHead;


extern WORD s_wOpticalYDpi[]; 
extern WORD s_wOpticalXDpi[]; 
extern WORD g_X;
extern WORD g_Y;
extern WORD g_Width;
extern WORD g_Height;
extern WORD g_XDpi;
extern WORD g_YDpi;
extern WORD g_SWWidth;	
extern WORD g_SWHeight;	
extern WORD g_wPixelDistance; 
extern WORD g_wLineDistance;
extern WORD g_wMaxScanLines;
extern WORD g_wScanLinesPerBlock;
extern WORD g_wReadedLines;
extern WORD g_wtheReadyLines;
extern WORD g_wReadImageLines;
extern WORD g_wReadyShadingLine; 
extern WORD g_wStartShadingLinePos; 
extern WORD g_wLineartThreshold;

extern DWORD g_dwScannedTotalLines;
extern DWORD g_dwImageBufferSize;
extern DWORD g_BytesPerRow;
extern DWORD g_SWBytesPerRow;
extern DWORD g_dwCalibrationSize;
extern DWORD g_dwBufferSize;
extern DWORD g_dwTotalTotalXferLines;


extern unsigned short * g_pGammaTable;
extern char* g_pDeviceFile;

extern pthread_t g_threadid_readimage;

extern COLORMODE g_ScanMode;
extern TARGETIMAGE g_tiTarget;
extern SCANTYPE g_ScanType;
extern SCANSOURCE g_ssScanSource;
extern PIXELFLAVOR g_PixelFlavor;

extern SUGGESTSETTING g_ssSuggest;
extern Asic g_chip;

#endif

